<?php
if (!defined( 'ABSPATH' )) { exit; }

class ATEC_update_tools { 

public function atec_prefix($p) { return $p==='mega-cache'?'':'atec-'; }

public function atec_is_plugin_active($p) { return is_plugin_active($this->atec_plugin_path($p)); } 

public function atec_plugin_path($p): string 
{ 
	$prefix =	$this->atec_prefix($p);
	return esc_attr($prefix.$p).'/'.esc_attr($prefix.$p).'.php'; 
}

public function atec_tz_offset()
{	
	$tz=ini_get('date.timezone')??'';
	if ($tz==='') $tz=date_default_timezone_get();
	$dateTimeZone = new DateTimeZone($tz);
	$dateTime = new DateTime("now", $dateTimeZone);
	$timeOffset = $dateTimeZone->getOffset($dateTime);
	return (int) $timeOffset;
}
	
public function atec_get_readme($p)
{
	global $wp_filesystem; 	WP_Filesystem();
	$reg 				= '/Stable\stag:\s([\.\d]*)\s/m';
	$ver					= '';
	$prefix				=	$this->atec_prefix($p);
	$readmePath	= WP_PLUGIN_DIR.'/'.esc_attr($prefix.$p).'/readme.txt';
	$readme			= $wp_filesystem->get_contents($readmePath);
	if (!is_wp_error($readme)) { preg_match_all($reg, $readme, $matches); $ver=$matches[1][0]??''; }
	return $ver;
}

public function atec_get_latest()
{
	$atecURL = 'https://atecplugins.com/WP-Plugins/';
	$json = null; $mtime = null; $latestst=null; $gmt=null;
	$options=array('timeout' =>300, 'headers' => array('Content-Type' => 'application/json','X-Random' => wp_rand(0,99999)));
	$response=wp_remote_get(esc_url_raw($atecURL.'latestArr.json'),$options);
	if (!is_wp_error($response))
	{
		$content=$response['body']??'';
		if ($content!=='') 
		{
			$jsonContent=json_decode($content,true);
			if (isset($jsonContent[3])) 	{ $json=$jsonContent[0]; $mtime=$jsonContent[1]; $latestst=$jsonContent[2]; $gmt=$jsonContent[3]; } 
		}
	}
	return array('json'=>$json, 'mtime'=>$mtime, 'latest'=>$latestst, 'gmt'=>$gmt);
}

function __construct() {}
}
?>