<?php
if (!defined( 'ABSPATH' )) { exit; }
if (!class_exists('ATEC_wpc_tools')) @require_once('atec-wpc-tools.php');

class ATEC_wpcu_about { 
	
function __construct() {
	
$imgSrc = plugins_url( '/assets/img/', __DIR__);	
atec_reg_inline_style('wpmc_about', 'p { font-size: 1.2em; }'); 

echo '	
<div class="atec-g atec-g-50">
	<div class="atec-g">';
		atec_little_block('About · Mega Cache');
		echo '
		<div class="atec-border-white">
		<h4><span style="color:#2340b1;">Mega</span> <span style="color:#fe5300;">Cache</span> is a lightweight page cache plugin.</h4>
		<p>
			It will cache pages/posts on the first request and will immediatelly return the cached content on every subsequent request/visitor. This approach will bypass almost all wordpress processes, thereby reducing the response time by an order of magnitude.<br><br>
			Also, the <strong>CPU footprint</strong>, the <strong>memory usage</strong> and the number of <strong>database queries</strong> will be <strong>reduced</strong> drastically. With these savings <strong><span style="color:#fe5300;">your server can handle a <u>lot</u> more requests</strong></span> at the same time.<br>
			No hardware upgrades required!
		</p>

		<h4 class="atec-mb-10">Cache Comparsion <span class="atec-fs-12">(Typical values for a fast server.)</span></h4>
		<table class="atec-table atec-table-tiny">
		<tr>
			<td></td>
			<td class="atec-bold">'; atec_server_sys_icon(__DIR__,'cpu'); echo '<small>Ø</small> CPU time</td>
			<td class="atec-bold">'; atec_server_sys_icon(__DIR__,'ram'); echo '<small>Ø</small> Memory</td>
			<td class="atec-bold">'; atec_server_sys_icon(__DIR__,'db'); echo '<small>Ø</small> Queries</td>
		</tr>
		<tr>
			<td class="atec-bold">No Cache</td>
			<td>150 <small>ms</small></td><td>5000 <small>KB</small></td><td>30</td>
		</tr>			
		<tr>
			<td class="atec-bold"><span style="color:#2340b1;">Mega</span> <span style="color:#fe5300;">Cache</span></td>
			<td>1 <small>ms</small></td><td>15 <small>KB</small></td><td>0</td>
		</tr>
		<tr style="background:#f0fff0;">
			<td>Magnitude</td>
			<td class="atec-bold"><small>x</small> 150</td><td class="atec-bold"><small>x</small> <small>≈</small> 300</td><td class="atec-bold"><small>x</small> 30</td>
		</tr>			
		</table>

		<p>Explained: The average CPU time to deliver a cached page is 1/150 of the time it would take to generate the page from scratch. So, <span style="color:#2340b1;">Mega</span> <span style="color:#fe5300;">Cache</span> is <strong>150 times faster</strong>, requires only <strong><small>≈</small> 0.3 <small>%</small> of memory </strong> and completely <strong>bypasses the WordPress database</strong> (versus 30 queries)!</p>

		<p>
		On the client side, page caching will reduce the waiting time for the server response as shown below.<br>
		In this real-world example, the response time is reduced by 100 <small>ms</small>. So any additional ressource will be queued 100 <small>ms</small> earlier.</p>
		<table>
		<tr>';
			// @codingStandardsIgnoreStart
			// Image is not an attachement
			echo '
			<td style="text-align: center;"><img style="height: 200px;" src="', esc_url($imgSrc.'RT1.png'), '"><br>Response with No Cache</td>
			<td>&nbsp;</td>
			<td style="text-align: center;"><img style="height: 200px;" src="', esc_url($imgSrc.'RT2.png'), '"><br>Response with <span style="color:#2340b1;">Mega</span> <span style="color:#fe5300;">Cache</span></td>';
			// @codingStandardsIgnoreEnd
		echo '
		</tr>
		</table>
		</div>
	</div>';
	
	$imgSrc = plugins_url( '/assets/img/icons/', __DIR__);	

	echo '	
	<div class="atec-g">';
		atec_little_block('About · Page Cache Options');
		echo '
		<div class="atec-border-white">
		<h4><span style="color:#2340b1;">Mega</span> <span style="color:#fe5300;">Cache</span> is a MULTI cache plugin.</h4>
		<p>
			While most other cache plugins support only a single storage option (typically saving to disk), <span style="color:#2340b1;">Mega</span> <span style="color:#fe5300;">Cache</span> supports <strong>eight memory/storage options</strong>!<br><br>
			You can choose any of the options that your system provides. Naturally memory based options will be faster than disk based options, thereby reducing response time even more.
		</p>
		<h4 class="atec-mb-10">Memory/storage options</h4>
		
		<table class="atec-table atec-table-tiny atec-mb-20">';
			// @codingStandardsIgnoreStart
			// Image is not an attachement
			echo '
			<tr><td>'; atec_server_sys_icon(__DIR__,'disk'); echo '<td colspan="4">File</td></tr>
			<tr><td>'; atec_server_sys_icon(__DIR__,'ram'); echo '<td>APCu</td><td>Redis</td><td colspan="2">Memcached</td></tr>
			<tr><td>'; atec_server_sys_icon(__DIR__,'db'); echo '<td>SQLite</td><td>MongoDB</td><td>MariaDB</td><td>MySQL</td></tr>';
			// @codingStandardsIgnoreEnd
		echo '
		</table>
		
		<h4 class="atec-mb-10">WordPress permalink structure</h4>
		<p class="atec-mb-20"><span style="color:#2340b1;">Mega</span> <span style="color:#fe5300;">Cache</span> <strong>supports all permalink options</strong>, where many other cache plugins require you to switch to ‘postname’.</p>
		
		<h4 class="atec-mb-10">Auto cache refresh</h4>
		<p>Whenever there are changes to the content, <span style="color:#2340b1;">Mega</span> <span style="color:#fe5300;">Cache</span> will automatically take care of flushing the respective parts of the page cache, to guarantee fresh content.</p>
	</div>
</div>';

}}

new ATEC_wpcu_about();
?>