<?php
if (!defined( 'ABSPATH' )) { exit; }
if (!class_exists('ATEC_wpc_tools')) @require_once('atec-wpc-tools.php');

class ATEC_wpmc_dashboard { 

private function atec_wpmc_os_icon()
{
	switch (php_uname('s'))
	{
		case 'Darwin': return 'apple'; break;
		case 'Windows': return 'windows'; break;
		case 'Linux': return 'linux'; break;
		case 'Ubuntu': return 'ubuntu'; break;
	}
	return '';
}

private function atec_wpmc_is_mega_cache($dir) 
{ 
	$advancedCachePath=$dir.'/advanced-cache.php';
	global $wp_filesystem; WP_Filesystem();
	$status=$wp_filesystem->exists($advancedCachePath)?1:0;
	if ($status===1) $status=str_contains($wp_filesystem->get_contents($advancedCachePath), 'Advanced Mega Cache')?2:1;
	return $status;
}

function __construct() {
	
atec_admin_debug('Mega Cache','wpmc');
require_once('atec-wpmc-connect.php'); $wpc_tools=new ATEC_wpc_tools();

echo '
<div class="atec-page">';

	$imgSrc			= plugins_url( '/assets/img/mega-cache-logo.webp', __DIR__ );
	$supportLink	= 'https://wordpress.org/support/plugin/mega-cache/';
	
	global $wpdb, $atec_wpmc_settings;
	$type 		= $atec_wpmc_settings['type']??'';
	$tableIdx 	= $atec_wpmc_settings['idx']??'';
	// @codingStandardsIgnoreStart
	$inUse=$tableIdx!=='' && $wpdb->get_var($wpdb->prepare('SELECT `id` FROM %1s LIMIT 1', $tableIdx));
	$db=[];
	$db['version'] 	= $wpdb->get_var('SELECT VERSION()');
	$db['name'] 		= str_contains(strtolower($db['version']), 'mariadb')?'MariaDB':'MySQL';
	$db['version'] 	= str_replace('-MariaDB', '', $db['version']);
	$db['info'] 		= array('name'=>$db['name'], 'version'=>$db['version']);
	// @codingStandardsIgnoreEnd
	
	$licenseOk = atec_header(__DIR__,'wpmc','Mega-Cache');
	
	echo '
	<div class="atec-main">';
		atec_progress();
			
		$advStatus 	= $this->atec_wpmc_is_mega_cache(WP_CONTENT_DIR);
	
		echo '<div class="atec-sticky-left">';
			// @codingStandardsIgnoreStart
			// Image is not an attachement
			echo '<img src="'. esc_url(plugins_url( '/assets/img/atec_wpmc_icon_admin.svg', __DIR__ )) .'" style="height:14px; margin-right: 4px;">';
			// @codingStandardsIgnoreEnd
			echo '<span class="atec-', esc_attr($advStatus===2?'green':'red'), '">MCache is ', ($advStatus===2?'enabled ('.esc_attr($type).')':'disabled'), '.</span>
		</div>';
	
		$url				= atec_get_url();
		$nonce			= wp_create_nonce(atec_nonce());
		$nav 			= atec_clean_request('nav');
		if ($nav=='') $nav='Dashboard';	
		
		$navs	= array('#home Dashboard','#gear Settings'); 

		if ($atec_wpmc_settings['cache']??false) $navs[]='#blog MCache';
		if ($inUse) { $navs[]='#'.($type==='File'?'disk':(in_array($type,['SQLite','Database'])?'database':'memory')).' '.$type; }
		
		atec_nav_tab($url, $nonce, $nav, $navs, 999, !$licenseOk,$atec_wpmc_settings['type']??'',true,$licenseOk,true);

		echo '
		<div class="atec-g atec-border">';
		
			if ($nav=='Info') { @require_once('atec-info.php'); new ATEC_info(__DIR__); }
			elseif ($nav=='Dashboard') { @require_once(__DIR__.'/atec-wpmc-profiler.php'); new ATEC_wpmc_profiler($url, $nonce, $wpc_tools, $this->atec_wpmc_os_icon(), $db['info'], $advStatus); }
			elseif ($nav=='Update') { @require_once(__DIR__.'/atec-wpmc-update-pro.php'); new ATEC_wpmc_update($url, $nonce); }
			elseif ($nav=='Debug') { @require_once(__DIR__.'/atec-wpmc-debug.php'); }
			elseif ($nav=='About') { @require_once(__DIR__.'/atec-wpmc-about.php'); }
			elseif ($nav=='Settings') { @require_once(__DIR__.'/atec-wpmc-settings.php'); new ATEC_wpcu_settings($wpc_tools,$this->atec_wpmc_os_icon(),$db['info'], $advStatus); }
			elseif (in_array($nav,['APCu','Redis','Memcached','SQLite','MongoDB','Database','File']))
			{ 
				$salt = $atec_wpmc_settings['salt']??'';
				require_once('atec-wpmc-groups.php'); new ATEC_wpmc_groups($type,$salt,$url,$nonce,$wpc_tools); 
			}
			elseif ($nav=='MCache') {@require_once(__DIR__.'/atec-wpmc-pcache-stats.php'); new ATEC_wpcu_pcache($url,$nonce,$wpc_tools); }
			
		echo '
		</div>
	</div>
</div>';

if (!class_exists('ATEC_footer')) @require_once('atec-footer.php');

}}

new ATEC_wpmc_dashboard();
?>