<?php
if (!defined('ABSPATH')) { exit; }

function atec_wpmc_regExp($config,$key,$subst): array
{
	if (!str_contains($config, '\''.$key.'\'')) { $reg = '/\<\?php\n{0,0}/'; $subst="<?php\n/* Added by mega-cache */\n".$subst; 	}
	else { $reg = '/define\(\s?\''.$key.'\',\s?[\']?([\w\d]*)[\']?\s?\);/'; }
	return ['reg'=>$reg, 'subst'=>$subst];
}

function atec_wpmc_set_wp_cache($wp_filesystem,$activate)
{
	$wpConfigPath = ABSPATH.'/wp-config.php';
	$config=$wp_filesystem->get_contents($wpConfigPath);
	$backupPath=str_replace('.php','.php.mega-cache-bck.txt',$wpConfigPath);
	$wp_filesystem->delete($backupPath);
	$wp_filesystem->put_contents($backupPath,$config);
	$regArr=atec_wpmc_regExp($config,'WP_CACHE',"define( 'WP_CACHE', ".($activate?'true':'false')." );");
	$new=preg_replace($regArr['reg'],$regArr['subst'], $config);
	if ($config!==$new) return $wp_filesystem->put_contents($wpConfigPath,$new);
	return true;
}

function atec_wpmc_delete_adv_cache($wp_filesystem,$dir)
{	
	$target=$dir.'/advanced-cache.php';
	if ($wp_filesystem->exists($target)) 
	{
		$content=$wp_filesystem->get_contents($target);
		if (str_contains($content,'Advanced Mega Cache')) { $wp_filesystem->delete($target); }
		else return __('Another `advanced-cache.php´ file already exists','mega-cache').
		'. Please disable the conflicting plugin and re-activate `mega-cache´ to complete the installation.';
	}
	return '';
}

function atec_wpmc_install_adv_cache($activate)
{
	global $wp_filesystem; 	WP_Filesystem();
	
	$result1=atec_wpmc_delete_adv_cache($wp_filesystem,WP_CONTENT_DIR);
	if ($result1!=='') { atec_admin_notice('warning',$result1); return false; }

	$notice='';
	$advCache='';

	if ($activate)
	{
		$source 		= plugin_dir_path(__DIR__) . 'install/advanced-cache.php.txt';
		$target 		= WP_CONTENT_DIR.'/advanced-cache.php';
		$result 			= @$wp_filesystem->copy($source,$target,true);
		if (!$result)
		{
			$notice 		= $advCache.'/advanced-cache.php installation failed.';
			atec_admin_notice('warning',$notice); return false; 
		}
		
		if (!atec_wpmc_set_wp_cache($wp_filesystem,$activate)) 
		{ $notice = 'Setting WP_CACHE failed.'; atec_admin_notice('warning',$notice); return false; }
	}
	else atec_wpmc_set_wp_cache($wp_filesystem,false);
		
	return true;
}
?>