<?php
if (!defined( 'ABSPATH' )) { exit; }

function atec_wpmc_delCache($args, $id=null): void
{
	global $wpdb, $atec_wpmc_settings;
	if (!$atec_wpmc_settings) $atec_wpmc_settings=get_option('atec_WPMC_settings',[]);

	$salt 		= $atec_wpmc_settings['salt']??'';
	$type 		= $atec_wpmc_settings['type']??'';
	
	$prefix		= 'atec_WPMC_'.$salt.'_';
	$key 		= $prefix.$args;

	if (in_array($type,['APCu','Redis','Memcached'])) $hitKey = $prefix.'@'.$args;
	
	if ($type!=='APCu') 
	{ 
		global $atec_wpmc_source; 
		if (!$atec_wpmc_source) { @require_once(__DIR__.'/atec-wpmc-connect.php'); atec_wpmc_connect($type); }
		$s=$atec_wpmc_source[strtolower($type)];
		if (!isset($s)) return;
	}
	switch ($type)
	{
		case 'APCu': apcu_delete($key); apcu_delete($hitKey); break;
		case 'Redis': $s->del($key); $s->del($hitKey); break;
		case 'Memcached': $s->delete($key); $s->delete($hitKey); break;
		case 'SQLite': $s->exec("DELETE FROM atec_wpmc WHERE `key`='{$args}'"); break;
		case 'MongoDB':
			try 
			{
				$bulk 	= new MongoDB\Driver\BulkWrite;																	
				$bulk->delete(['_id' => $args]);
				$result = $s->executeBulkWrite('db.atec_wpmc', $bulk);
			}
			catch (MongoDB\Driver\Exception\Exception $e) { }
			break;
		case 'Database': 
			// @codingStandardsIgnoreStart
			$wpdb->delete($s, array('key' => sanitize_key($args)));
			// @codingStandardsIgnoreEnd
			break;
		case 'File':
			global $wp_filesystem;
			if (empty($wp_filesystem)) { require_once (ABSPATH . '/wp-admin/includes/file.php'); WP_Filesystem(); }
			// if (!function_exists('WP_Filesystem')) require_once(ABSPATH . 'wp-admin/includes/file.php');
			// global $wp_filesystem; WP_Filesystem(); 
			$wp_filesystem->delete($s.$args.'.txt'); break;
	}		

	$tableIdx 	= $atec_wpmc_settings['idx']??'';
	// @codingStandardsIgnoreStart
	if ($id) $wpdb->delete($tableIdx, array('id'=>$id), array('%d'));
	else $wpdb->delete($tableIdx, array('key'=>$args), array('%s'));
	// @codingStandardsIgnoreEnd

}

?>