<?php
if (!defined( 'ABSPATH' )) { exit; }

function atec_wpmc_delAll($type=''): bool
{
	global $atec_wpmc_settings;
	if (!$atec_wpmc_settings) $atec_wpmc_settings=get_option('atec_WPMC_settings',[]);

	if ($type==='') { $type=$atec_wpmc_settings['type']??false; }
	if (!$type) return true;
	
	if ($type!=='APCu') 
	{ 
		global $atec_wpmc_source;
		if (!$atec_wpmc_source) { @require_once(__DIR__.'/atec-wpmc-connect.php'); atec_wpmc_connect($type); }
		$s=$atec_wpmc_source[strtolower($type)]; 
		if (!isset($s)) return false;
	}
	if (in_array($type,['Redis','Memcached'])) { @require_once(__DIR__.'/atec-wpmc-pcache-keys.php'); $allKeys = atec_wpmc_Array(true); }
	
	global $wpdb;
	$salt 		= $atec_wpmc_settings['salt']??'';
	$prefix 	= 'atec_WPMC_'.$salt.'_';	
	
	switch ($type)
	{
		case 'APCu': if (class_exists('APCUIterator')) { $arr=new APCUIterator('/atec_WPMC_/'); if (iterator_count($arr)!==0) foreach ($arr as $a) { apcu_delete($a['key']); } } break;
		case 'Redis': foreach ($allKeys as $key) { $s->del($prefix.$key->key); $s->del($prefix.'@'.$key->key); } break;
		case 'Memcached': foreach ($allKeys as $key) { $s->delete($prefix.$key->key); $s->delete($prefix.'@'.$key->key); } break;
		case 'SQLite':	 $s->exec('DELETE FROM atec_wpmc'); $s->exec('VACUUM main'); break;
		case 'MongoDB':
			try 
			{
				$bulk 	= new MongoDB\Driver\BulkWrite;																	
				$bulk->delete([]);
				$result = $s->executeBulkWrite('db.atec_wpmc', $bulk);
			}
			catch (MongoDB\Driver\Exception\Exception $e) { }
			break;
		case 'Database': global $wpdb; 
			// @codingStandardsIgnoreStart
			$wpdb->query($wpdb->prepare('TRUNCATE TABLE %s', $s)); 
			// @codingStandardsIgnoreEnd
			break;
		case 'File': 
			global $wp_filesystem;
			if (empty($wp_filesystem)) { require_once (ABSPATH . '/wp-admin/includes/file.php'); WP_Filesystem(); }
			// if (!function_exists('WP_Filesystem')) require_once(ABSPATH . 'wp-admin/includes/file.php');
			// global $wp_filesystem; WP_Filesystem();
			$wp_filesystem->rmdir($s,true); $wp_filesystem->mkdir($s);
			break;
	}
	
	$tableIdx=$atec_wpmc_settings['idx']??''; 
	// @codingStandardsIgnoreStart
	$wpdb->query($wpdb->prepare('TRUNCATE TABLE %1s', $tableIdx)); 
	// @codingStandardsIgnoreEnd
	
	return empty($allKeys);
}

?>