<?php
if (!defined( 'ABSPATH' )) { exit; }

function atec_wpmc_getCache($type,$salt,$args,$incr=false)
{
	$prefix = 'atec_WPMC_'.$salt.'_';
	$key 	= $prefix.$args;
	if ($incr && in_array($type,['APCu','Redis','Memcached'])) $hitKey = $prefix.'@'.$args;

	if ($type!=='APCu') 
	{ 
		global $atec_wpmc_source; require_once(__DIR__.'/atec-wpmc-connect.php'); atec_wpmc_connect($type,false); 
		$s=$atec_wpmc_source[strtolower($type)];
	}	
	$arr=[];
	switch ($type)
	{
		case 'APCu': $arr=apcu_fetch($key); if ($incr) apcu_inc($hitKey); break;
		case 'Redis': $arr=@unserialize($s->get($key)); if ($incr) $s->incr($hitKey); break;
		case 'Memcached': $arr=$s->get($key); if ($incr) $s->increment($hitKey); break;
		case 'SQLite':	
			$result = @$s->querySingle("SELECT DISTINCT content FROM atec_wpmc WHERE key='{$args}' LIMIT 1");
			if (!is_null($result)) $arr=@unserialize($result);
			break;
		case 'MongoDB':
			try 
			{
				$query = new MongoDB\Driver\Query(['_id' => $args], ['limit' => 1]);
				$result = $s->executeQuery('db.atec_wpmc', $query);
				foreach ($result as $val) $bson=$val->content->getData();
				$arr=@unserialize($bson);
			}
			catch (MongoDB\Driver\Exception\Exception $e) { }
			break;
		case 'Database':
			global $wpdb;
			if ($wpdb)
			{
				// @codingStandardsIgnoreStart
				$result=$wpdb->get_row($wpdb->prepare('SELECT content FROM %s WHERE `key`=%s LIMIT 1', $s, $args));
				if (!is_null($result)) $arr=@unserialize($result->content);
				// @codingStandardsIgnoreEnd
			}
			else
			{
				if (!defined('DB_NAME')) require_once(ABSPATH.'wp-config.php');
				// @codingStandardsIgnoreStart
				// $wpdb is not loaded at this point, when used by advanced-cache.php. Therefore using plain PHP function. 
				$mysqli = new mysqli(DB_HOST,DB_USER,DB_PASSWORD,DB_NAME);
				$result=$mysqli->query($sql);
				if (!is_null($result)) { $row=$result->fetch_assoc(); $arr=@unserialize($row['content']); }
				// @codingStandardsIgnoreEnd
			}
			break;
		case 'File': 
			// @codingStandardsIgnoreStart
			// WP_Filesystem is not loaded at this point, when used by advanced-cache.php. Therefore using plain PHP function. 
			$arr=@unserialize(@file_get_contents($s.$args.'.txt')); break;
			// @codingStandardsIgnoreEnd
	}		
	
	return $arr;
}

?>