<?php
if (!defined( 'ABSPATH' )) { exit; }

class ATEC_wpcu_pcache { 

function __construct($url,$nonce,$wpc_tools) {

$action = atec_clean_request('action');

global $atec_wpmc_settings;
$salt=$atec_wpmc_settings['salt']??'';
$type=$atec_wpmc_settings['type']??'';
$arr=array('Type'=>$type,'Zlib'=>(@ini_get('zlib.output_compression')??'Off'?'On':'Off'), 'PCache salt'=>$salt);
atec_little_block_with_info(__('Cached pages and posts','mega-cache'),$arr);

echo '
<div class="atec-g">
<div>';

	atec_wpmc_connect($type,!str_starts_with($action,'delete'));
	
	if ($action==='delete')
	{
		if (($id=atec_clean_request('id'))!=='') 
		{ 
			global $wpdb;
			// @codingStandardsIgnoreStart
			$results=$wpdb->get_results($wpdb->prepare('SELECT `id`, `key` FROM %1s WHERE pid=%d LIMIT 1', $atec_wpmc_settings['idx']??'', sanitize_key($id)));
			// @codingStandardsIgnoreEnd
			if (isset($results[0]->id)) { @require_once(__DIR__.'/atec-wpmc-pcache-delete.php'); atec_wpmc_delCache($results[0]->key,$results[0]->id); }
		}
	}
	elseif ($action==='delete_all')
	{
		atec_flush();
		@require_once(__DIR__.'/atec-wpmc-pcache-deleteAll.php'); atec_wpmc_delAll($type);
		atec_success_msg('Page cached flushed ('.$type.')');
	}
	
	$hitsAvail=in_array($type,['APCu','Redis','Memcached']);
	if ($hitsAvail) @require_once(__DIR__.'/atec-wpmc-pcache-getHits.php'); 
	@require_once(__DIR__.'/atec-wpmc-pcache-keys.php'); 
	$keyArr=atec_wpmc_Array();

	if (!empty($keyArr))
	{
    	echo '
    	<table class="atec-table atec-table-tiny atec-table-td-first">
	    	<thead>
	    	<tr>
				<th>'.esc_attr__('Type','mega-cache').'</th>
				<th>URL</th>
				<th>ID</th>
				<th><span title="'.esc_attr__('Page Nr.','mega-cache').'" class="'.esc_attr(atec_dash_class('admin-page')).'"></span></th>
				<th>'.esc_attr__('Hits','mega-cache').'</th>
				<th>'.esc_attr__('Size','mega-cache').'</th>
				<th>'.esc_attr__('Title','mega-cache').'</th>
				<th>Link</th>
				<th></th>
			</tr>
			</thead>
			<tbody>';					    
	    		$c=0; $totalSize=0;
	    		$reg=preg_replace('/\//','\/',preg_replace('/https?:\/\//','',get_home_url()));
				$keyReg = '/atec_WPMC_[a-z\d]*_.*/';
	    		foreach ($keyArr as $key) 
	    		{	
					$c++; 
					$isCat			= $key->suffix==='c';
					$isTag			= $key->suffix==='t';
					$id 				= $key->pid;
					$hits 			= $hitsAvail?atec_wpmc_getHits($salt,$key->key,$type):'./.';
					$totalSize 	+= $key->size;
					
					if ($isCat) { $postType='Category'; $link=@get_category_link($id); $title=@get_cat_name($id); }
					elseif ($isTag) { $postType='Tag'; $link=@get_tag_link($id); $title=@get_tag($id)->name; }
					else
					{
						$link = ($key->suffix==='x')?@get_post_permalink($id):@get_page_link($id);
						if (str_ends_with($link, '?page_id=')) $link.=$id;
						$postType = ($key->suffix==='a')?'Page':($key->suffix==='x'?get_post_type($id):'Post');
						$title = @get_the_title($id);
					}			

					$short_url 	= preg_replace('/(^https?:\/\/)'.$reg.'/', '', $link);
					echo '
					<tr>
						<td>', esc_attr($postType), '</td>
						<td>', esc_attr($key->key), '</td>					
						<td>', esc_attr($key->pid), '</td>
						<td>', esc_attr(99), '</td>
						<td>', esc_attr($hits), '</td>
						<td class="atec-nowrap">', esc_attr(size_format($key->size)), '</td>
						<td>', esc_html($title), '</td>
						<td><a href="', esc_url($link), '" target="_blank">', esc_url($short_url), '</a></td>';
						atec_create_button('delete&nav=MCache','trash',true,$url,$key->pid,$nonce);
					echo '
					</tr>';
	    		}
        		if ($c>0) echo '<tr class="atec-table-tr-bold"><td colspan="7">',esc_attr(number_format($c)),'</td><td class="atec-nowrap">',esc_attr(size_format($totalSize)),'</td><td colspan="3"></td></tr>';
				else echo '<tr><td colspan="10">./.</td></tr>';
			echo '
    		</tbody>
    	</table>';
    	if ($c>0) atec_nav_button($url,$nonce,'delete_all','MCache','',false,true);
	}
	else { $wpc_tools->p(__('No page cache data available','mega-cache').' ('.$type.')'); }

echo '
</div></div>';

}}
?>