<?php
if (!defined( 'ABSPATH' )) { exit; }

function atec_wpmc_delete_page_cache($id,$suffix): void
{
	global $wpdb, $atec_wpmc_settings;
	if (!$atec_wpmc_settings) $atec_wpmc_settings=get_option('atec_WPMC_settings',[]);
	// @codingStandardsIgnoreStart
	$results=$wpdb->get_results($wpdb->prepare('SELECT `id`, `key` FROM %1s WHERE suffix=%s AND pid=%d LIMIT 1', $atec_wpmc_settings['idx']??'', sanitize_key($suffix), sanitize_key($id)));
	// @codingStandardsIgnoreEnd
	if (isset($results[0]->id)) { @require_once(__DIR__.'/atec-wpmc-pcache-delete.php'); atec_wpmc_delCache($results[0]->key,$results[0]->id); }
}

function atec_wpmc_delete_page_cache_all(): void { @require_once(__DIR__.'/atec-wpmc-pcache-deleteAll.php'); atec_wpmc_delAll(); }
function atec_wpmc_update_category_cache($category_id): void { atec_wpmc_delete_page_cache($category_id,'c'); }
function atec_wpmc_update_tag_cache($term_id, $tt_id, $taxo): void { atec_wpmc_delete_page_cache($term_id,'t'); }

function atec_wpmc_update_page_cache($post_id, $post_after, $post_before) 
{
	if (in_array($post_after->post_type,['attachment','revision','nav_menu_item','wp_template','wp_template_part'])) return;
	if (wp_is_post_revision($post_id)) return;
	$suffix = $post_after->post_type==='page'?'a':($post_after->post_type==='post'?'o':'x');
	atec_wpmc_delete_page_cache($post_id,$suffix);
	$taxos=['tag'=>'t','category'=>'c'];
	foreach($taxos as $key=>$value)
	{
		$result = get_the_terms($post_id, $key);
		if (!is_wp_error($result) && !empty($result)) foreach($result as $t) { atec_wpmc_delete_page_cache($t->term_id,$value); }
	}
}
?>