<?php
if (!defined( 'ABSPATH' )) { exit; }

class ATEC_wpmc_profiler { 

private function atec_wpmc_bar($time,$max):void { echo '<td>'; atec_bar_div($time,$max,0.5,0.1); echo '</td>'; }

public $imgSrc;

function __construct($url,$nonce,$wpc_tools,$osIcon,$dbInfo,$advStatus) {

if (!defined('ATEC_CHECK_INC')) @require_once('atec-check.php');
@require_once(__DIR__.'/atec-wpmc-enabled.php');

global $wp_filesystem, $atec_wpmc_settings;
WP_Filesystem();
$this->imgSrc = plugins_url( '/assets/img/icons/', __DIR__);

echo '	
<div class="atec-g atec-g-50">
	<div class="atec-g">';
		atec_little_block('Mega Cache · Options');

		echo '
		<div class="atec-border-white">';
			
			$freeSpace=disk_free_space(ABSPATH);
			
			echo '
			<div class="atec-g atec-g-50">
				<div class="atec-mr-10 atec-dilb">
					<table class="atec-table atec-mb-20 atec-table-tiny">
						<thead><th colspan="2">Advanced Cache Status</th></thead>
						<tbody>';

							$wp_cache=defined('WP_CACHE') && WP_CACHE;
							
							echo '<tr><td>WP_CACHE</td><td>'; $wpc_tools->enabled($wp_cache); echo '</td></tr>';
							echo '<tr><td>WP_CONTENT/advanced-cache.php</td><td>'; $wpc_tools->enabled($advStatus===2); echo '</td>'; 
							
						echo '
						</tbody>
					</table>					
				</div>
				
				<div class="atec-dilb atec-mb-20">';
					atec_flush();
					echo'
					<table class="atec-table atec-mb-5 atec-table-tiny">
						<thead><th colspan="2">Memory & Storage</th></thead>
						<tbody>
							<tr>
								<td class="atec-TDBR atec-bold">', esc_attr__('Free disk','mega-cache'), '</td>
								<td>',esc_attr(size_format($freeSpace)),'</td>
							</tr>
						</tbody>
					</table>
				</div>
			</div>';
			
			if ($advStatus===1) atec_warning_msg('The advanced-cache.php is not a `mega-cache´file. Your are using another page cache already');
			elseif ($advStatus===0 && ($atec_wpmc_settings['cache']??false)) atec_error_msg('The advanced-cache.php was not installed or removed.<br>Please re-enable caching');
			atec_badge('MCache is enabled ('.esc_attr($atec_wpmc_settings['type']??'').')','MCache is disabled',$advStatus===2 && $atec_wpmc_settings['cache']??false);

			$link = get_admin_url().'admin.php?page=atec_wpmc&nav=Settings&_wpnonce='.esc_attr(wp_create_nonce('atec_wpmc_nonce'));
			if ($advStatus<2) 
			{
				echo '<br><p>Status must be active for the page cache to work.<br>Please enable caching in the `<a href="', esc_url($link), '">Settings</a>´  tab.</p>';
				atec_nav_button($url,$nonce,'Settings','Settings','Enable Caching',true,true);
			}

			$atec_wpca_settings=get_option('atec_WPCA_settings',[]);
			if ($atec_wpca_settings['cache']??false) atec_error_msg('Active `atec-Cache-APCu´ detected!<br>Do not use multiple page cache plugins simultaneously.<br>Please disable the other plugin before you continue');

	echo '
		</div>
	</div>';
	
	
	echo '
	<div class="atec-g">';
		
		if (!$advancedCacheIsMC) 
		{ 
			atec_little_block('Mega Cache · Statistics'); 
			echo '<div class="atec-border-white">';
			atec_info_msg('Not available – page cache is disabled'); 
			echo '</div>';
		}
		else
		{
			$upload_dir  	= wp_get_upload_dir()['basedir'].'/mega-cache';
			$logPath 		= $upload_dir.'/mega-cache-log.json';

			$action		= atec_clean_request('action');
			if ($action==='delete') $wp_filesystem->delete($logPath);

			$log 				= trim($wp_filesystem->get_contents($logPath));
			$mtime 		= @filectime($logPath);
			$logCreated 	= $mtime?gmdate('y:m:d H:i', $mtime):'./.';
			
			$arr=array('Since'=>esc_attr($logCreated));
			atec_little_block_with_info('Mega Cache · Statistics',$arr,'',array('delete'),$url,$nonce);

			echo '
			<div class="atec-border-white">';
			if ($log==='') atec_error_msg('Log file is empty');
			else
			{
				if (($arrSize=sizeof($arr=explode("\n",$log)))>0)
				{
					$jsonArr=[];
					$countNC=0; $ttNC=0; $memNC=0; $queriesNC=0;
					$countMC=0; $ttMC=0; $memMC=0; $queriesMC=0;
					$max=0;
					foreach ($arr as $a) 
					{ 
						$json=json_decode($a,true);
						if ($json['cache']) { $countMC++; $ttMC+=$json['time']; $memMC+=$json['mem']; $queriesMC+=$json['queries']; }
						else { $countNC++; $ttNC+=$json['time']; $memNC+=$json['mem']; $queriesNC+=$json['queries']; }
						$jsonArr[]=$json;
						if ($max===0 || $json['time']>$max) $max=$json['time'];
					}
				
					unset($arr);
					$NCavg=$countNC>0?$ttNC/$countNC:0;
					$MCavg=$countMC>0?$ttMC/$countMC:0;
						
					$NCavgMem=$countNC>0?$memNC/$countNC:0;
					$MCavgMem=$countMC>0?$memMC/$countMC:0;
						
					$NCavgQueries=$countNC>0?$queriesNC/$countNC:0;
					$MCavgQueries=$countMC>0?$queriesMC/$countMC:0;

					$avgTime=($ttNC+$ttMC)/$arrSize;
					$avgMem=($memNC+$memMC)/$arrSize;
					$avgQueries=($queriesNC+$queriesMC)/$arrSize;
					
					echo
					'<div class="atec-db">';
							if ($arrSize>0 && $NCavg!==0)
							{
							echo 
							'<div class="atec-dilb atec-border atec-bg-w atec-center atec-mb-10 atec-p-5">
								<div class="atec-db">
									<div class="atec-dilb atec-mr-10">
										<h4 class="atec-bold atec-mt-0">Savings</h4>
									</div>
									<div class="atec-dilb atec-center">
										<div id="pagescore" class="atec-dilb atec-border" style="height: 40px; width:80px; background: rgba(200,255,200,0.5); padding-top: 10px; border-radius: 10%; font-size:1.75em; font-weight:600;">', esc_attr(number_format(100-($avgTime/$NCavg*100))), '<span class="atec-fs-12">&nbsp;%</span>
										</div>
									</div>
								</div>
							</div>
							<br>';
							}

						echo '
						<div class="atec-dilb">
						<table class="atec-table atec-mb-5 atec-table-tiny">
							<thead>
								<tr>
									<th></th>
									<th>Requests</th>
									<th class="atec-nowrap"><small>Ø</small> '; atec_icon(__DIR__,'#memory'); echo '</th>
									<th class="atec-nowrap"><small>Ø</small> '; atec_icon(__DIR__,'#database'); echo '</th>
									<th class="atec-nowrap"><small>Ø</small> '; atec_icon(__DIR__,'#stopwatch'); echo '</th>
									<th>Processing time</th>
								</tr>
							</thead>
							<tbody>
								<tr>
									<td class="atec-TDBR">No Cache</td>
									<td>', esc_attr(number_format($countNC)), '</td>
									<td>', esc_attr(size_format($NCavgMem)), '</td>
									<td>', esc_attr(number_format($NCavgQueries)), '</td>
									<td>', esc_attr($countNC>0?number_format($NCavg*1000,1):'./.'), '&nbsp;<small>ms</small></td>';
									if ($NCavg>0) $this->atec_wpmc_bar($NCavg,$max);
									else echo '<td></td>';
									echo '
								</tr>
								<tr>
									<td class="atec-TDBR"><span style="color:#2340b1;">Mega</span> <span style="color:#fe5300;">Cache</span></td>
									<td>', esc_attr(number_format($countMC)), '</td>
									<td>', esc_attr(size_format($MCavgMem)), '</td>
									<td>', esc_attr(number_format($MCavgQueries)), '</td>
									<td>', esc_attr($countMC>0?number_format($MCavg*1000,2):'./.'), '&nbsp;<small>ms</small></td>';
									if ($MCavg>0) $this->atec_wpmc_bar($MCavg,$max);
									else echo '<td></td>';
								echo '
								</tr>';
								atec_empty_tr();	
								echo '
								<tr>
									<td><small>Ø</small></td>
									<td class="atec-bold">', esc_attr(number_format($arrSize)), '</td>
									<td>', esc_attr(size_format($avgMem)), '</td>
									<td>', esc_attr(number_format($avgQueries)), '</td>
									<td>', esc_attr($avgTime>0?number_format($avgTime*1000,2):'./.'), '&nbsp;<small>ms</small></td>';
									if ($avgTime>0) $this->atec_wpmc_bar($avgTime,$max);
									else echo '<td></td>';
									echo '
								</tr>
							</tbody>
						</table>
						</div>
					</div>';

					echo '
					<br>
					<div class="atec-db atec-fit" style="max-height: 480px; overflow-y: auto; overflow-x:hidden; padding-right: 20px;">
					<table class="atec-table atec-table-tiny">
						<thead>
							<tr>
								<th>Cached</th>
								<th class="atec-nowrap">'; atec_icon(__DIR__,'#memory'); echo '</th>
								<th class="atec-nowrap">'; atec_icon(__DIR__,'#database'); echo '</th>
								<th class="atec-nowrap"><small>Ø</small> '; atec_icon(__DIR__,'#stopwatch'); echo '</th>
								<th>Processing time</th>
							</tr>
						</thead>
						<tbody>';
				
						$totalTime=0; $c=0;
						foreach ($jsonArr as $a) 
						{
							$c++;
						  	echo '
						  	<tr>
									<td class="atec-a-right">'; $wpc_tools->enabled($a['cache']); echo '</td>
									<td class="atec-a-right">', esc_attr(size_format($a['mem'])), '&nbsp;ms', '</td>
									<td class="atec-a-right">', esc_attr(number_format($a['queries'])), '&nbsp;ms', '</td>
									<td class="atec-a-right">', esc_attr(round($a['time']*1000,2)), '&nbsp;ms', '</td>
									<td>
										<div class="atec-barDiv atec-bg-w">
										<span class="atec-bar" style="width:',
											esc_attr($a['time']/$max*100), 'px;';
											if ($a['time']>0.5) echo ' background: red;'; elseif ($a['time']>0.1) echo ' background: orange;';
									echo '">
										</span>
										</div>
									</td>
								</tr>';
							$totalTime+=$a['time'];
						}
				
						echo '
						</tbody>
					</table>
					</div>';
				}
			}
		}
		echo '
		</div>
	</div>
</div>';

}}
?>