<?php
if (!defined( 'ABSPATH' )) { exit; }

function atec_wpmc_arr_equal($arr1, $arr2) { array_multisort($arr1); array_multisort($arr2); return ( serialize($arr1) === serialize($arr2) ); }

function atec_wpmc_select($args): void
{
	global $atec_wpmc_types;
	$option = get_option($args['opt-name'],[]); $field=$args['name']; $value=$option[$field]??'false';
	echo '
	<select name="', esc_attr($args['opt-name']), '[', esc_attr($field), ']" id="', esc_attr($field), '">';
	foreach ($atec_wpmc_types as $type) echo '<option ', selected($type,$value,true), ' value="', esc_attr($type), '">', esc_attr($type), '</option>';
	 echo '
	</select>';
}

function atec_wpmc_settings_fields()
{ 
	$page_slug 		= 'atec_WPMC';
    $option_group 	= $page_slug.'_settings';
    $section			= $page_slug.'_section';
	$options			= get_option($option_group,[]);
	
	if (str_contains(atec_query(),'settings-updated=true')) 
	{
		if (!($options['salt']??false)) { $options['salt']=hash('crc32', get_bloginfo(), FALSE); update_option($option_group,$options); }

		$lastSettings=get_option('atec_WPMC_settings_last',[]);
		if (!atec_wpmc_arr_equal($options,$lastSettings))
		{ 
			$writeJson=false;
			$cacheChanged = ($lastSettings['cache']??false)!==($options['cache']??false);  
			if ($cacheChanged || ($lastSettings['type']??false)!==($options['type']??''))
			{
				$writeJson=true;
				$atec_wpmc_last_type=$lastSettings['type']??'';
				// ** flush the pcache if pcache settings change ** //
				@require_once(__DIR__.'/atec-wpmc-connect.php'); atec_wpmc_connect($atec_wpmc_last_type,false);
				@require_once(__DIR__.'/atec-wpmc-pcache-deleteAll.php'); $empty=atec_wpmc_delAll($atec_wpmc_last_type); 
				if (!$empty) update_option( 'atec_wpmc_debug', ['type'=>'info', 'message'=>'PCache '.__('cleared','mega-cache').'.'],false);
				update_option('atec_WPMC_settings_last',$options,false);
				
				if ($cacheChanged)
				{
					@require_once(__DIR__.'/atec-wpmc-install-cache.php'); $result=atec_wpmc_install_adv_cache($options['cache']??false);
					if (!$result) { $options['cache']=false; update_option($option_group,$options); }
				}
			}
			if (($lastSettings['log']??false)!==($options['log']??false)) { $writeJson=true; update_option('atec_WPMC_settings_last',$options,false); }
			if ($writeJson)
			{
				$arr=array($page_slug.'_settings'=>$options, $page_slug.'_extensions'=>get_option($page_slug.'_extensions',[]));
				global $wp_filesystem; WP_Filesystem();
				$wp_filesystem->put_contents(wp_get_upload_dir()['basedir'].'/mega-cache/mega-cache.json',wp_json_encode($arr));
			}			
		};
	}

  	function wpmc_optArr($opt) { return array('name'=>$opt, 'opt-name' => 'atec_WPMC_settings' ); };
	
  	register_setting(sanitize_text_field($page_slug),sanitize_text_field($option_group));
	
  	add_settings_section($section,__('Page Cache','mega-cache'),'',$page_slug);
	
  	$middot='&middot;&middot;&middot;&#187;&#187; ';
  	add_settings_field('cache', __('Enable page cache','mega-cache'), 'atec_checkbox', $page_slug, $section, wpmc_optArr('cache'));
	  
  	add_settings_field('type', $middot.__('Cache type','mega-cache').'<br>
	  	<span style="font-size:80%; color:#999;">'.__('The memory/storage where pages are cached','mega-cache').'.</span>', 'atec_wpmc_select', $page_slug, $section, wpmc_optArr('type'));

	if ($options['cache']??false)
	{

		add_settings_field('custom', $middot.__('Cache custom post types','mega-cache').'<br>
  			<span style="font-size:80%; color:#a00;">'.__('Might deliver outdated content if it is dynamic','mega-cache').'.</span>', 'atec_checkbox', $page_slug, $section, wpmc_optArr('custom'));
	
  		add_settings_section($section.'_debug','Page Cache Options','',$page_slug);

  		add_settings_field('debug', $middot.__('Cache indicator','mega-cache').'<br>
  			<span style="font-size:80%; color:#999;">'.__('Show cache indicator and browser console log','mega-cache').'.</span>', 'atec_checkbox', $page_slug, $section.'_debug', wpmc_optArr('debug'));
		
		add_settings_field('minify', $middot.__('Minify HTML','mega-cache').'<br>
			<span style="font-size:80%; color:#999;">'.__('Remove white space and comment tags','mega-cache').'.</span>', 'atec_checkbox', $page_slug, $section.'_debug', wpmc_optArr('minify'));

		add_settings_field('log', $middot.__('Cache statistics','mega-cache').'<br>
			<span style="font-size:80%; color:#999;">'.__('Write log file on each request','mega-cache').'.<br><span class="atec-orange">'.__('Recommende for testing only, not for production','mega-cache').'.</span></span>', 'atec_checkbox', $page_slug, $section.'_debug', wpmc_optArr('log'));

	 }
}
add_action( 'admin_init',  'atec_wpmc_settings_fields' );

?>