<?php
if (!defined( 'ABSPATH' )) { exit; }

class ATEC_wpcu_settings {
	
public function atec_wpmc_cache_icon($type,$logo=false):void 
{ 
	$imgSrc=!$logo?str_replace('logos','icons',$this->imgSrc):$this->imgSrc;
	// @codingStandardsIgnoreStart
	// Image is not an attachement
	echo '<img class="atec-sys-icon" src="', esc_url($imgSrc.strtolower($type).'.svg'), '">';
	// @codingStandardsIgnoreEnd
}

private function atec_wpmc_cache_option($url,$nonce,$type,$logo=false):void
{
	$lower=strtolower($type);
	switch ($lower)
	{
		case 'file': $icon='disk'; break;
		case 'apcu':
		case 'redis':				
		case 'memcached': $icon='memory'; break;
		default: $icon='database'; break;
	}
	$option=$this->wpmc_active[$lower]??0;
	echo '<tr ', (!$this->wpmc_enabled[$lower]?' style="background: rgba(255, 81, 81, 0.08);"':'') ,'>
	<td>'; $this->atec_wpmc_cache_icon($icon); echo '</td>',
	'<td>'; $this->atec_wpmc_cache_icon($logo?$logo:$lower,true); echo '</td>',
	'<td>', esc_attr($type); echo '</td>',
	'<td>'; atec_checkbox_button($type,$type,!$this->wpmc_enabled[$lower],$option,$url,'&nav=Settings&action=active&id='.$lower.'&set='.($option?'false':'true'),$nonce); echo '</td>',
	'<td>', $type==='File'?'':'<span class="atec-pro">PRO</span>', '</td>',
	'</tr>';
}
	
public function atec_wpmc_sys_icon($type,$pro=true):void 
{ 
	// @codingStandardsIgnoreStart
	// Image is not an attachement
	echo '<img class="atec-right atec-sys-icon atec-mr-0" style="width: auto; height: 18px;" src="', esc_url($this->imgSrc.strtolower($type).'.svg'), '">';
	// @codingStandardsIgnoreEnd
	if ($pro) echo '<span class="atec-right atec-pro atec-ml-20 atec-mr-10">PRO</span>';
	else echo '<span class="atec-ml-20"></span>';
}
	
private function atec_wpmc_active($str,$type) { return $str===$type?'background: rgba(100,255,100,0.15); border: solid 2px green;':''; }

private function atec_wpmc_div_head($type) 
{ 
	$active=$this->wpmc_active[strtolower($type)]??false;
	$style=$active?'':' display:none; ';
	if (!$active) echo '<div style="order:1; width:100%; height:0;"></div>';
	echo '<div style="max-height: fit-content; height:', ($active?'auto':'38px'), '; order:', ($active?'0':'2'), ';', esc_attr($style), '" class="atec-mb-', ($active?'20':'10') ,' atec-dilb atec-vat atec-border atec-pb-0 atec-pt-0 atec-mr-10">'; 
	atec_flush();
	return $active;
}
private function atec_wpmc_span_type($typeName,$id='',$value='') 
{ 
	$id=$id===''?'':' id='.$id.'Connection';
	$value=$value===''?'':'('.$value.')';
	echo ' ', esc_attr($typeName), ' <span class="atec-fs-8" ', esc_attr($id) ,'>', esc_attr($value) ,'</span>'; 
}

private function atec_wpmc_div_settings($wpc_tools,$typeName,$id='',$connected=true) 
{
	if (!$connected) { echo '<div id="', esc_attr($id), 'settingsDiv" class="atec-dilb atec-mb-10 atec-mr-10">'; $wpc_tools->error($typeName,('is not connected')); echo '</div>'; }
	echo 
	'<div class="atec-dilb atec-right">
		<button id="', esc_attr($id), 'Btn" class="settingsBtn atec-bg-w6" 
		onclick="jQuery(\'#', esc_attr($id), 'Form\').removeClass(\'atec-dn\'); jQuery(\'#', esc_attr($id), 'Btn, #', esc_attr($id), 'Table, #', esc_attr($id), 'settingsDiv\').remove();">
		<span class="', esc_attr(atec_dash_class('admin-settings')), '"></span></button>
	</div>';
}

public $wpmc_enabled;
public $wpmc_active;
public $imgSrc;
	
function __construct($wpc_tools,$osIcon,$dbInfo,$advStatus) {

$this->imgSrc = plugins_url( '/assets/img/logos/', __DIR__);	

if (!defined('ATEC_CHECK_INC')) @require_once('atec-check.php');
@require_once(__DIR__.'/atec-wpmc-enabled.php');
$this->wpmc_enabled = &$atec_wpmc_enabled;

global $atec_wpmc_types, $atec_wpmc_source, $atec_wpmc_extensions, $atec_wpmc_settings;

$nonce					= wp_create_nonce(atec_nonce());
$url						= atec_get_url();
$nav 					= atec_clean_request('nav');
$action 				= atec_clean_request('action');
$type 					= $atec_wpmc_settings['type']??'';

$writeable 				= [];
$atec_wpmc_key 		= 'atec_wpmc_key';
$optName 				= 'atec_WPMC_active';
$atec_wpmc_active 	= get_option($optName,[]);
$this->wpmc_active = &$atec_wpmc_active;

if ($action=='active')
{
	$id = atec_clean_request('id');
	$set = atec_clean_request('set')=='true';
	$atec_wpmc_active[$id]=$set?1:0;
	update_option($optName,$atec_wpmc_active,false); 
}

atec_reg_inline_style('','
INPUT { font-size: 12px; line-height: 12px; padding: 2px; } LABLE { font-size: 12px; } .form-table SELECT { background: rgba(100,255,100,0.15); }
.settingsBtn { border-radius: 3px; }
.atec-red { margin-top: 5px; }
');

echo '	
<div class="atec-g atec-g-50">
	<div class="atec-g">';
		atec_little_block('Page Cache Types');

		echo '
		<div class="atec-border-white" style="margin-top: -2px;">
			<h4>Enabled Cache Types</h4>';
			atec_wpmc_connect('File');
			$freeSpace=disk_free_space(rtrim($atec_wpmc_source['file'],DIRECTORY_SEPARATOR));

			$typeName='File';
			$active=$this->atec_wpmc_div_head($typeName);
				if ($active)
				{
					echo '
					<h4>'; 
						$wpc_tools->enabled($atec_wpmc_enabled['file'],!$active);
						$this->atec_wpmc_span_type($typeName,'','Disk');
						$this->atec_wpmc_sys_icon($osIcon,false);
					echo '
					</h4>';

					global $wp_filesystem; 	WP_Filesystem();
				
					$used=0;
					$files=$wp_filesystem->dirlist($atec_wpmc_source['file'],false,false);
					if ($files) foreach($files as $file) if (str_ends_with($file['name'],'.txt')) $used+=$file['size'];
			
					echo'
					<table class="atec-table atec-mb-5 atec-table-tiny" style="', esc_attr($this->atec_wpmc_active($typeName,$type)) ,'">
						<tbody>
							<tr>
								<td>', esc_attr__('Free disk','mega-cache'), '</td>
								<td>', esc_attr__('Used','mega-cache'), '</td>
								<td>' ,esc_attr__('Available','mega-cache'), '?</td>
							</tr>
							<tr>
								<td>',esc_attr(size_format($freeSpace)),'</td>
								<td>',esc_attr(size_format($used)),'</td>';
								echo '
								<td>';
								
								$filename='atec_WPMC_test.txt';
								$result=$wp_filesystem->put_contents($atec_wpmc_source['file'].$filename,'hello');
								if ($result) { $atec_wpmc_types[]=$typeName; $wp_filesystem->delete($atec_wpmc_source['file'].$filename); atec_success_msg($typeName);	 }
								else atec_error_msg($typeName);	
								
								echo '
								</td>
							</tr>
						</tbody>
					</table>';
				}
				echo'
			</div>';
		
			$licenseOk=atec_pro_feature('BREAK#The free version only supports file storage',true);
			if (!$licenseOk) { echo '<br>'; $atec_wpmc_types=['File']; }
			
			$typeName='APCu'; $apcu_memory_type='';
			$active=$this->atec_wpmc_div_head($typeName);
				if ($atec_wpmc_enabled['apcu'])
				{
					if ($active)
					{						
						$writeable[$typeName]=false;
						if (apcu_add($atec_wpmc_key,'hello')) { $atec_wpmc_types[]=$typeName; apcu_delete($atec_wpmc_key); $writeable[$typeName]=true;	}
						$apcu_cache=apcu_cache_info(true);
						$apcu_memory_type=($apcu_cache['memory_type']??false)?esc_attr($apcu_cache['memory_type']):'';
					
						echo '
						<h4>'; 
							$wpc_tools->enabled($atec_wpmc_enabled['apcu'] && $writeable[$typeName],!$active); 
							$this->atec_wpmc_span_type($typeName,'',$apcu_memory_type);
							$this->atec_wpmc_sys_icon($typeName); 
						echo '
						</h4>';

						if ($apcu_cache)
						{
							$apcu_mem	= apcu_sma_info();
							echo'
							<table class="atec-table atec-mb-5 atec-table-tiny" style="', esc_attr($this->atec_wpmc_active($typeName,$type)) ,'">
							<tbody>
								<tr>
									<td>', esc_attr__('Ver.','mega-cache'), '</td>
									<td>', esc_attr__('Memory','mega-cache'), '</td>
									<td>', esc_attr__('Used','mega-cache'), '</td>
									<td>', esc_attr__('Available','mega-cache'), '?</td>
								</tr>
								<tr>
									<td>', esc_attr(phpversion('apcu')), '</td>
									<td>', esc_attr(size_format($apcu_mem['num_seg']*$apcu_mem['seg_size'])), '</td>
									<td>', esc_attr(size_format($apcu_cache['mem_size'])), '</td>
									<td>'; atec_badge($typeName,$typeName,$writeable[$typeName]); echo '</td>
								</tr>
							</tbody>
							</table>';
						}
						else $wpc_tools->error($typeName,__('cache data could NOT be retrieved','mega-cache'));
					}
				}
				else $wpc_tools->error($typeName,__('extension is NOT enabled','mega-cache'));
			echo '
			</div>';
				
			$redSettings 	= $atec_wpmc_extensions['redis']??[];
			$memSettings 	= $atec_wpmc_extensions['memcached']??[];
			
			$arr = 
			[
				['action'=>'saveRed', 'type'=>'redis', 'fields'=>['unix','host','port','pwd']],
				['action'=>'saveMem', 'type'=>'memcached', 'fields'=>['unix','host','port']]
			];
		
			foreach($arr as $a)
			{
				if ($action===$a['action'])
				{
					$option=$atec_wpmc_extensions[$a['type']]??[];
					foreach($a['fields'] as $o) $option[$o]=atec_clean_request($a['type'].'_'.$o);
					$atec_wpmc_extensions[$a['type']]=$option; update_option('atec_WPMC_extensions', $atec_wpmc_extensions, false); 
					if ($a['type']==='redis') $redSettings=$option;
					else $memSettings=$option;
				}
			}		

			$typeName='Redis';
			$active=$this->atec_wpmc_div_head($typeName);		
				if ($atec_wpmc_enabled['redis'])
				{
					if ($active)
					{
						@require_once(__DIR__.'/atec-wpmc-connect-redis.php'); atec_wpmc_connect_redis();
						$s=$atec_wpmc_source['redis'];
						
						$writeable[$typeName]=false;
						if ($s && $s->set($atec_wpmc_key,'hello')) { $atec_wpmc_types[]=$typeName; $s->del($atec_wpmc_key); $writeable[$typeName]=true;	}
					
						echo '
						<h4>'; 
							$wpc_tools->enabled($atec_wpmc_enabled['redis'] && $writeable[$typeName],!$active); 
							$this->atec_wpmc_span_type($typeName,'redis','');
							$this->atec_wpmc_sys_icon($typeName); 
						echo '
						</h4>';
					
						echo
						'<div class="atec-db">';
							$this->atec_wpmc_div_settings($wpc_tools,$typeName,'redis',$s);
							echo 
							'<div class="atec-dilb atec-vat atec-mb-10">
								<form id="redisForm" class="atec-dn atec-border-tiny atec-mb-0" method="post" action="'.esc_url($url).'&nav=Settings&action=saveRed&_wpnonce='.esc_attr($nonce).'">
									<table>
									<tr>
										<td>
											<label for="redis_host">', esc_attr__('Host','mega-cache'), '</lable><br>
											<input size="14" type="text" placeholder="Host" id="redis_host" name="redis_host" value="', esc_attr($redSettings['host']??''), '">
										</td>
										<td>
											<label for="redis_port">', esc_attr__('Port','mega-cache'), '</lable><br>
											<input size="6" type="text" placeholder="Port" id="redis_port" name="redis_port" value="', esc_attr($redSettings['port']??''), '">
										</td>
										<td>
											<label for="redis_pwd">', esc_attr__('Password','mega-cache'), '</lable><br>
											<input size="8" type="password" placeholder="Password" id="redis_pwd" name="redis_pwd" value="', esc_attr($redSettings['pwd']??''), '">
										</td>
									</tr>
									<tr>
										<td colspan="2">
											<label for="redis_unix">', esc_attr__('Unix socket','mega-cache'), '</lable><br>
											<input size="20" type="text" placeholder="Unix socket" name="redis_unix" value="', esc_textarea($redSettings['unix']??''), '">
										</td>
									</tr>
									<tr>
										<td colspan="2">
											<input class="button button-primary"  type="submit" value="Save">
											<div class="atec-right atec-ml-10">';
											atec_help('redis','Default values');
											echo '<div id="redis_help" class="atec-help atec-dn">Standard host/port: 127.0.0.1:6379.</div>
											</div>
										</td>
									</tr>
									</table>
								</form>
							</div>';
	
							if (is_object($s) && !empty($s))
							{
								try
								{
									$pong 		= $s->ping();
									$server 	= $atec_wpmc_source['redis']->info('server');
									$stats 		= $atec_wpmc_source['redis']->info('stats');
									$memory 	= $atec_wpmc_source['redis']->info('memory');
									
									$redisConfig=[];
									$redisConfig['unixsocket']=$s->config('GET','unixsocket')['unixsocket'];
									$redisConfig['bind']=$s->config('GET','bind')['bind'];
									$redisConfig['port']=$s->config('GET','port')['port'];
								
									atec_reg_inline_script('wpmc_redis','jQuery("#redisConnection").html(" ('.esc_attr(($redisConfig['unixsocket']==='')?$redisConfig['bind'].':'.$redisConfig['port']:$redisConfig['unixsocket']).')");', true);
									echo'
									<div id="redisTable" class="atec-dilb atec-vat atec-mr-10">
										<table class="atec-table atec-mb-5 atec-table-tiny" style="', esc_attr($this->atec_wpmc_active($typeName,$type)) ,'">
											<tbody>
												<tr>
													<td>Ver.</td>
													<td>', esc_attr__('Used','mega-cache'), '</td>
													<td>' ,esc_attr__('Available','mega-cache'), '?</td>
												</tr>
												<tr>
													<td>', esc_attr($server['redis_version']), '</td>
													<td>', esc_attr(size_format($memory['used_memory'])), '</td>
													<td>'; atec_badge($typeName,$typeName,$writeable[$typeName]); echo '</td>
												</tr>
											</tbody>
										</table>
									</div>';
								}
								catch (Exception $e) { $wpc_tools->error($typeName,(strtolower($e->getMessage()))); }
							}
						
						echo 
						'</div>';
					}
				}
				else $wpc_tools->error($typeName,esc_attr(__(' is NOT available','mega-cache')));			
				
			echo '
			</div>';
		
			$typeName='Memcached';
			$active=$this->atec_wpmc_div_head($typeName);
				if ($atec_wpmc_enabled['memcached'])
				{					
					if ($active)
					{					
						@require_once(__DIR__.'/atec-wpmc-connect-memcached.php'); atec_wpmc_connect_memcached();
						$s=$atec_wpmc_source['memcached'];
						
						if ($s->set($atec_wpmc_key,'hello')) { $atec_wpmc_types[]=$typeName; $s->delete($atec_wpmc_key); $writeable[$typeName]=true;	}
						
						echo '
						<h4>'; 
							$wpc_tools->enabled($atec_wpmc_enabled['memcached'] && $writeable[$typeName],!$active); 
							$this->atec_wpmc_span_type($typeName,'memcached','');
							$this->atec_wpmc_sys_icon($typeName); 
						echo '
						</h4>';
									
						echo
						'<div class="atec-db">';
							$this->atec_wpmc_div_settings($wpc_tools,$typeName,'memcached',$s);
							echo 
							'<div class="atec-dilb atec-vat atec-mb-10">';
							
								$memUnix = $memSettings['unix']??'';
								if ($memUnix!=='') { $memHost=$memUnix; $memPort=0; }
								else { $memHost=$memSettings['host']??''; $memPort=$memSettings['port']??0; }

								echo
								'<form id="memcachedForm" class="atec-dn atec-border-tiny atec-mb-0" method="post" action="'.esc_url($url).'&nav=Settings&action=saveMem&_wpnonce='.esc_attr($nonce).'">
									<table>
									<tr>
										<td>
											<label for="memcached_host">', esc_attr__('Host','mega-cache'), '</lable><br>
											<input size="14" type="text" placeholder="Host" id="memcached_host" name="memcached_host" value="', esc_attr($memHost), '">
										</td>
										<td>
											<label for="memcached_port">', esc_attr__('Port','mega-cache'), '</lable><br>
											<input size="6" type="text" placeholder="Port" id="memcached_port" name="memcached_port" value="', esc_attr($memPort), '">
										</td>
										<tr>
											<td colspan="2"><label for="memcached_unix">', esc_attr__('Unix socket','mega-cache'), '</lable><br>
												<input size="20" type="text" placeholder="/home/memcached.socket" name="memcached_unix" value="', esc_textarea($memUnix), '">
											</td>
										</tr>		
									</tr>
									<tr>
										<td colspan="2">
											<input class="button button-primary"  type="submit" value="Save">
											<div class="atec-right atec-ml-10">';
											atec_help('memcached','Default values');
											echo '<div id="memcached_help" class="atec-help atec-dn">Standard host/port: 127.0.0.1:11211.</div>
											</div>
										</td>
									</tr>
									</table>
								</form>
							</div>';
						
							$mem=$s?$s->getStats():[];							
							if (!empty($mem) && ($mem = $mem[$memHost.':'.$memPort]??false))
							{
								atec_reg_inline_script('wpmc_memcached','jQuery("#memcachedConnection").html(" ('.esc_attr($memHost.':'.$memPort).')");', true);		
								echo'
								<div id="memcachedTable" class="atec-dilb atec-vat atec-mr-10">
									<table class="atec-table atec-mb-5 atec-table-tiny" style="', esc_attr($this->atec_wpmc_active($typeName,$type)) ,'">
										<tbody>
											<tr>
												<td>Ver.</td>
												<td>', esc_attr__('Memory','mega-cache'), '</td>
												<td>', esc_attr__('Used','mega-cache'), '</td>
												<td>' ,esc_attr__('Available','mega-cache'), '?</td>
											</tr>
											<tr>
												<td>',esc_attr($mem['version']),'</td>
												<td>',esc_attr(size_format($mem['limit_maxbytes']??0)),'</td>
												<td>',esc_attr(size_format($mem['bytes']??0)),'</td>
												<td>'; atec_badge($typeName,$typeName,$writeable[$typeName]); echo '</td>
											</tr>
										</tbody>
									</table>
								</div>';
							}
							else $wpc_tools->error($typeName,__('status is NOT available','mega-cache'));
						
						echo 
						'</div>';
					}
				}
				else $wpc_tools->error($typeName,esc_attr(__('class is NOT available','mega-cache')));									
			echo '
			</div>';
			
			$typeName='SQLite';
			$active=$this->atec_wpmc_div_head($typeName);
				if ($atec_wpmc_enabled['sqlite'])
				{			
					if ($active)
					{	

						@require_once(__DIR__.'/atec-wpmc-connect-sqlite.php'); atec_wpmc_connect_sqlite(false);
						$s=$atec_wpmc_source['sqlite'];
						$writeable[$typeName]=false;
						if ($s)
						{
							$result=@$s->exec('INSERT INTO atec_wpmc ("key", "content") VALUES ("'.$atec_wpmc_key.'", "hello")');
							if ($result) { $s->exec('DELETE FROM atec_wpmc WHERE key="'.$atec_wpmc_key.'"'); $atec_wpmc_types[]=$typeName; $writeable[$typeName]=true;	}
						}

						echo '
						<h4>'; 
							$wpc_tools->enabled($atec_wpmc_enabled['sqlite'] && $writeable[$typeName],!$active);
							$this->atec_wpmc_span_type($typeName,'','Disk');
							$this->atec_wpmc_sys_icon($typeName); 
						echo '
						</h4>';

						echo'
						<table class="atec-table atec-mb-5 atec-table-tiny" style="', esc_attr($this->atec_wpmc_active($typeName,$type)) ,'">
							<tbody>
								<tr>
									<td>Ver.</td>
									<td>', esc_attr__('Memory','mega-cache'), '</td>
									<td>' ,esc_attr__('Available','mega-cache'), '?</td>
								</tr>
								<tr>
									<td>', esc_attr(SQLite3::version()['versionString']??''), '</td>
									<td>', esc_attr(size_format($freeSpace)),'</td>
									<td>'; atec_badge($typeName,$typeName,$writeable[$typeName]); echo '</td>
								</tr>
							</tbody>
						</table>';
					}
				}
				else $wpc_tools->error($typeName,esc_attr(__('class is NOT available','mega-cache')));	
			echo '
			</div>';
			
			$typeName='MongoDB';
			$active=$this->atec_wpmc_div_head($typeName);
				if ($atec_wpmc_enabled['mongodb'])
				{					
					if ($active)
					{

						@require_once(__DIR__.'/atec-wpmc-connect-mongodb.php'); atec_wpmc_connect_mongodb();
						$s=$atec_wpmc_source['mongodb'];
						
						$writeable[$typeName]=false;
						$success=true;
						if ($s)
						{
							try 
							{
								$doc 	= ['_id' => $atec_wpmc_key, 'content' => $atec_wpmc_key];
								$bulk 	= new MongoDB\Driver\BulkWrite;								
								$bulk->insert($doc);
								$result = $s->executeBulkWrite('db.atec_wpmc', $bulk);
								if ($result->getInsertedCount()!=0)
								{
									$bulk 	= new MongoDB\Driver\BulkWrite;																	
									$bulk->delete(['_id' => $atec_wpmc_key]);
									$result = $s->executeBulkWrite('db.atec_wpmc', $bulk);
								}
								else $success=false;
											
							}
							catch (MongoDB\Driver\Exception\Exception $e) { $success=false; }
						}
						else $success=false;
						if ($success) { $atec_wpmc_types[]=$typeName; $writeable[$typeName]=true;	}
					
						echo '
						<h4>'; 
							$wpc_tools->enabled($atec_wpmc_enabled['mongodb'] && $writeable[$typeName],!$active);
							$this->atec_wpmc_span_type($typeName,'','Disk');
							$this->atec_wpmc_sys_icon($typeName); 
						echo '
						</h4>';

						echo'
						<table class="atec-table atec-mb-5 atec-table-tiny" style="', esc_attr($this->atec_wpmc_active($typeName,$type)) ,'">
							<tbody>
								<tr>
									<td>Ver.</td>
									<td>', esc_attr__('Memory','mega-cache'), '</td>
									<td>' ,esc_attr__('Available','mega-cache'), '?</td>
								</tr>
								<tr>
									<td>', esc_attr(phpversion("mongodb")), '</td>
									<td>', esc_attr(size_format($freeSpace)),'</td>
									<td>'; atec_badge($typeName,$typeName,$writeable[$typeName]); echo '</td>
								</tr>
							</tbody>
						</table>';
					}
				}
				else $wpc_tools->error($typeName,esc_attr(__(' is NOT available','mega-cache')));	
			echo '
			</div>';
		
			$typeName='Database';		
			global $wpdb;
			$table=$atec_wpmc_extensions['database'];
			// @codingStandardsIgnoreStart
			$used 		= $wpdb->get_var($wpdb->prepare('SELECT SUM(CHAR_LENGTH(content)) AS used FROM %1s', $table));
			// @codingStandardsIgnoreEnd
			$active=$this->atec_wpmc_div_head($typeName);
				if ($active)
				{
					echo '
					<h4>'; 
						$wpc_tools->enabled($atec_wpmc_enabled['database'],!$active);
						$this->atec_wpmc_span_type($typeName,'','Database');
						$this->atec_wpmc_sys_icon($dbInfo['name']); 
					echo '
					</h4>';

					if (!$used) $used=0;
					echo'
					<table class="atec-table atec-mb-5 atec-table-tiny" style="', esc_attr($this->atec_wpmc_active($typeName,$type)) ,'">
						<tbody>
							<tr>
								<td>Ver.</td>
								<td>', esc_attr__('Used','mega-cache'), '</td>
								<td>', esc_attr__('Available','mega-cache'), '?</td>
							</tr>
							<tr>
								<td>', esc_attr($dbInfo['version']), '</td>
								<td>', esc_attr(size_format($used)),'</td>';
								echo '
								<td>';
								
								$insArr=array('key' =>$atec_wpmc_key, 'content'=>'');
								// @codingStandardsIgnoreStart
								if ($wpdb->insert($table, $insArr)) { $atec_wpmc_types[]=$typeName; $wpdb->delete($table, array('id' => $wpdb->insert_id)); atec_success_msg($typeName); }
								else atec_error_msg($typeName);
								// @codingStandardsIgnoreEnd
								echo '
								</td>
							</tr>
						</tbody>
					</table>';
				}
			echo'
			</div>';
				
			echo '
			<hr class="atec-clear">
			<h4 class="atec-mb-0">Available Cache Types</h4>
			<p class="atec-mt-0">(Enabled extensions)</p>
			<div class="atec-db atec-mb-10">
				<div class="atec-dilb mr-10">
					<table class="atec-table atec-mb-5 vat">
						<tbody>';
							$this->atec_wpmc_cache_option($url,$nonce,'File',$osIcon);
							$this->atec_wpmc_cache_option($url,$nonce,'APCu');
							$this->atec_wpmc_cache_option($url,$nonce,'Redis');
							$this->atec_wpmc_cache_option($url,$nonce,'Memcached'); 
						echo '
						</tbody>
					</table>
				</div>
				<div class="atec-dilb">
					<table class="atec-table atec-mb-5 vat">
						<tbody>';
							$this->atec_wpmc_cache_option($url,$nonce,'SQLite');
							$this->atec_wpmc_cache_option($url,$nonce,'MongoDB');
							$this->atec_wpmc_cache_option($url,$nonce,'Database',$dbInfo['name']); 
						echo '
						</tbody>
					</table>
				</div>
			</div>
			
			<p class="atec-mt-0 atec-fs-12">To improve admin interface performance,<br>keep options disabled, that you do not use.</p>';
		
			if (defined('LITESPEED_ALLOWED') && LITESPEED_ALLOWED) 
			{ 
				echo '<div class="atec-mb-20">';
					atec_badge('',__('LiteSpeed-server and -cache plugin detected','mega-cache'),false); 
					atec_badge(__('Please disable LiteSpeed page cache if you want to use mega-cache','mega-cache'),'',true); 
				echo '</div>';
			}

			atec_help('multi','PCache plugins');
			echo '
			<div id="multi_help" class="atec-help atec-dn">',
				'<p class="atec-red">', esc_attr__('Do not use multiple page cache plugins simultaneously.','mega-cache'), '</p>',
			'</div>';

		echo '
		</div>
	</div>';

	if (!$licenseOk) { $atec_wpmc_types=['File']; }
	echo '
	<div class="atec-g">';
		$arr=array('MCache'=>$advStatus===2?'Enabled':'Disabled');
		atec_little_block_with_info('Page Cache – Settings',$arr,$advStatus===2?'atec-green':'atec-red');
		echo '
		<div class="atec-border-white">';
			echo '
			<div id="atec_WPMC_settings">
  				<form method="post" action="options.php">
			  	<input type="hidden" name="atec_WPMC_settings[salt]" value="', esc_attr($atec_wpmc_settings['salt']??''), '">
				<input type="hidden" name="atec_WPMC_settings[idx]" value="', esc_attr($atec_wpmc_settings['idx']??''), '">';
			  	
				$slug = 'atec_WPMC';
  				settings_fields($slug);
  				do_settings_sections($slug);
  				submit_button(__('Save','mega-cache'));

				echo '
				</form>
				<div>';
				
					atec_help('debug','Debug');
					echo '
					<div id="debug_help" class="atec-help atec-dn">',
					esc_attr__('The debug feature is for temporary use. It will show a small green circle in the upper left corner, when the page is served from cache. In addition you will find further details in your browser console. Please flush the page cache, once you are done with testing.','mega-cache'),
					'</div>
				</div>
			</div>
		</div>
		
	</div>
	
</div>';

if (!($atec_wpmc_settings['cache']??false)) atec_reg_inline_style('wpmc_settings_form', '#debug_help_button { display:none !important; }'); 

}}

?>