<?php
if (!defined( 'ABSPATH' )) { exit; }

class ATEC_wpmc_update { 

public $megaURL;
	
function __construct($url,$nonce) {
	
if (!class_exists('ATEC_update_tools')) @require_once('atec-update-tools.php');
$wpdp_tools = new ATEC_update_tools();

global $wp_filesystem; 	WP_Filesystem();
$action = atec_clean_request('action');

$this->megaURL = 'https://wpmegacache.com/WP-Plugins/';
	
	atec_little_block('Update');
	atec_flush(); 
	
	if ($action==='mega_update')
	{
		$megaURL 	= 'https://wpmegacache.com/WP-Plugins/mega-cache.zip';
		$error			= '';
		$tmp_file = download_url($megaURL);
		if (is_wp_error($tmp_file)) { $error='Could not download the .zip file'; }
		else 
		{
			if ($wp_filesystem->exists($tmp_file) && $wp_filesystem->size($tmp_file)>50000) 
			{ 
				//$wp_filesystem->rmdir(WP_PLUGIN_DIR.DIRECTORY_SEPARATOR.'mega-cache',true);
				$result=unzip_file($tmp_file, WP_PLUGIN_DIR);
				if (is_wp_error($result)) $error='Could not unzip the .zip file';
				$wp_filesystem->delete($tmp_file);
			}
			else $error='The .zip file is corrupt';
		}
		atec_badge('Mega-Cache was self-updated successfully',$error,$error==='');
	}
		
	echo '
	<div id="atec_wpmc_loading" class="atec-dilb atec-left atec-mb-10">
		<div>Loading latest version list . . . ';
			if (function_exists('atec_loader_dots')) atec_loader_dots();
		echo '
		</div>
		<br class="atec-clear">
	</div>';
	
	$response=wp_remote_get(esc_url_raw($this->megaURL.'latestArr.json'),array('timeout'=>2));
	if (!is_wp_error($response))
	{
		$content=$response['body']??'';
		if ($content!=='') 
		{
			$jsonContent=json_decode($content,true);
			if (isset($jsonContent[3])) 	{ $json=$jsonContent[0]; $mtime=$jsonContent[1]; $latestst=$jsonContent[2]; $gmt=$jsonContent[3]; } 
		}
	}

	$jsonArr 				= $latest['json'];
	$remoteMtimeArr = $latest['mtime'];
	$megaLatest 		= $mtime['mega-cache'];
	
	$isPro = $wp_filesystem->exists(__DIR__.'/atec-pro.php');
	$pluginMtime = $wp_filesystem->mtime(WP_PLUGIN_DIR.'/mega-cache/readme.txt');
	$outDated = $megaLatest>$pluginMtime;
	
	echo '
	<div>';
		atec_table_header_tiny(['Plugin ver.','Cloud ver.','PRO','Action']);
		
			echo '
			<tr>
				<td>', esc_attr(wp_cache_get('atec_wpmc_version')), '<br>
					<div style="margin-top: -3px;" class="atec-nowrap atec-fs-8 ', ($outDated?'atec-red':'atec-green'), '">', esc_attr(gmdate('m/d H:i', $pluginMtime)), '</div>
				</td>
				<td>', esc_attr($json['mega-cache']??''), '<br>
					<div style="margin-top: -3px;" class="atec-nowrap atec-fs-8">', esc_attr(gmdate('m/d H:i', $megaLatest)), '</div>
				</td>
				<td>';
				if ($isPro) echo'<span class="', $isPro?esc_attr(atec_dash_class('awards','atec-blue')):'', '"></span>';
				echo '
				</td>
				<td>';
				if ($outDated) 
				{
					if (!$isPro) echo '<a title="Download PRO version from wpmegacache.com" class="atec-nodeco atec-vam button button-secondary" style="padding: 0px 4px;" target="_blank" href="https://wpmegacache.com/WP-Plugins/mega-cache.zip" download=""><span style="padding-top: 4px;" class="dashicons dashicons-download"></span> Download latest</a>';
					else atec_nav_button($url,$nonce,'mega_update','Update','#update Update',true,true);
				}
				else echo './.';
				echo '
				</td>
			</tr>
			</tbody>
		</table>
	</div>';

	atec_reg_inline_script('atec_wpmc_update','jQuery("#atec_wpmc_loading, .atec-loader-dots").slideUp();');
}}

?>