<?php
if (! defined('ABSPATH') ) { die('Forbidden'); }

function atec_mu_wpmc_log($cache)
{
	global $timestart, $atec_mu_wpmc_mem, $atec_mu_wpmc_queries;
	$atec_mu_wpmc_queries=function_exists('get_num_queries')?get_num_queries():0;
	// @codingStandardsIgnoreStart	
	file_put_contents(
		MEGA_CACHE_UPLOAD.'/mega-cache-log.json',
		'{"cache":'.($cache?'1':'0').
		',"time":'.(microtime(true)-$timestart).
		',"mem":'.(memory_get_usage()-$atec_mu_wpmc_mem).
		',"queries":'.($atec_mu_wpmc_queries).
		'}'."\n", FILE_APPEND);
	// @codingStandardsIgnoreEnd
}

// @codingStandardsIgnoreStart
// Can not use wp_unslash at this point, as this function is not available in advanced-cache.php.	
$atec_mu_wpmc_args 	= stripslashes($_SERVER['REQUEST_URI']??'');
// @codingStandardsIgnoreEnd

if (!preg_match('/\/wp\-admin|\/login|\/password\-reset|\.(png|gif|bmp|je?pg|json|map|css|js)/', $atec_mu_wpmc_args))
{
	// @codingStandardsIgnoreStart
	/* $_POST and $_SERVER is uncritical as it is only used for comparison */
	if 
	(
		(str_contains($_SERVER["HTTP_COOKIE"]??'','wordpress_logged_in')) ||
		(basename($_SERVER['PHP_SELF']??'')!=='index.php') || 
		(in_array($_SERVER['REQUEST_METHOD']??'', array( 'POST', 'PUT', 'DELETE' ),true)) ||
		str_contains($atec_mu_wpmc_args, '/feed')
	) { @header('X-Cache: SKIP'); return; }
	/* Using native PHP function to improve speed by not loading the complete WP_Filesystem class. This will save more than 1 ms per request. */
	$json=@file_get_contents(MEGA_CACHE_UPLOAD.'/mega-cache.json');
	// @codingStandardsIgnoreEnd	
	$arr=$json?json_decode($json):[];
	foreach($arr as $key=>$value)
	{
		switch ($key)
		{
			case 'atec_WPMC_settings': $atec_wpmc_settings=(array) $value; break;
			case 'atec_WPMC_extensions': 
				$atec_wpmc_extensions=(array) $value; 
				$atec_wpmc_extensions['redis']=(array) $atec_wpmc_extensions['redis']??[]; 
				$atec_wpmc_extensions['memcached']=(array) $atec_wpmc_extensions['memcached']??[]; 
				break;			
		}
	}
	$log=$atec_wpmc_settings['log']??false;
	if ($log) $atec_mu_wpmc_mem = @memory_get_usage();
	$type=$atec_wpmc_settings['type']??'';
	$atec_mu_wpmc_args = str_replace(['/','?'],['_','#'],$atec_mu_wpmc_args);
	if (!defined('WP_PLUGIN_DIR')) define('WP_PLUGIN_DIR',WP_CONTENT_DIR.'/plugins');
	require_once(WP_CONTENT_DIR.'/plugins/mega-cache/includes/atec-wpmc-pcache-get.php');
	$arr = atec_wpmc_getCache($type,$atec_wpmc_settings['salt']??'',$atec_mu_wpmc_args,true);
	
	if (!empty($arr))
	{	
		$charset=$atec_wpmc_settings['charset']??'UTF-8';
		@header('Content-Type: text/html; charset='.$charset);
		@header('X-Cache-Enabled: TRUE');	
		@header('X-Cache-Type: Mega Cache ('.$type.')');
		@header('Content-Length: '.strlen($arr[1]));
		// @codingStandardsIgnoreStart
		// wp_unslash() is not available at this point – so using stripslashes.
		if (str_contains(stripslashes($_SERVER['HTTP_ACCEPT_ENCODING']??''), 'gzip') && $arr[0])
		// @codingStandardsIgnoreEnd
		{
			// @codingStandardsIgnoreStart
			// If zlib.output is not disabled, gzip content will be gziped again, and output will result in an encoding error.
			// Block ends with exit() – so no other script will be envolved.
			// As discussed with review team, GZIP content can not be sanitized/escaped as that would corrupt the content. */
			$zlib='zlib.output_compression'; $ini=ini_get($zlib);
			if ($ini==1 || strtolower($ini)=='on') ini_set($zlib,'Off');
			header('Vary: Accept-Encoding');
			header("Content-Encoding: gzip");
			@header('X-Cache: HIT/GZIP');
			echo $arr[1];
			// @codingStandardsIgnoreEnd
		}
		else
		{
			@header('X-Cache: HIT');
			if ($arr[0] && function_exists('gzdecode')) $arr[1] = gzdecode($arr[1]);
			/* As discussed with review team, GZIP content can not be sanitized/escaped as that would corrupt the content. */
			// @codingStandardsIgnoreStart
			echo $arr[1];
			// @codingStandardsIgnoreEnd
		}
		if ($log) atec_mu_wpmc_log(true);
		exit(200);
	}
	else @require_once(WP_CONTENT_DIR.'/plugins/mega-cache/includes/atec-wpmc-pcache.php');
	if ($log) add_action('shutdown', function() { atec_mu_wpmc_log(false); 	});
}
?>